//+------------------------------------------------------------------+
//|                                                                  |
//|                      Copyright  2006 Sunwest3d  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "CCI Sample by Sunwest3D, Idea from BrunoFX  2006"
// CCI function from coderguru

extern int CCI = 14;
extern int Method=0; 		// 0 = CCI from metatrader / Value 1 = CCI from coderguru
extern double TakeProfit = 40
extern double ProfitModifySL=20;
extern double StopLoss= 60;
extern double TrailingStop=30;

extern double Slippage = 3;
extern double Lots=0.1;

extern color clOpenBuy = Blue;
extern color clOpenSell = Red;
extern color clCloseBuy = Aqua;
extern color clCloseSell = Violet;
extern color clModiBuy = Blue;
extern color clModiSell = Red;


int Position=0;
int    Magic;
bool  CalDoneEA;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
   Position=0;
   CalDoneEA=true;
   Magic = Period()+777;
   return(0);
  }
  
//+------------------------------------------------------------------+
//|     Start of the EA Sample                                       |
//+------------------------------------------------------------------+
int start()
  {
   double CCIc,CCIp;
   
   if (Volume[0]==1 && CalDoneEA==false)  // Update it only at the first tick of every bar
   {
      if (Method==0)
      	CCIc=iCCI(Symbol(),0,CCI,PRICE_CLOSE,1);  // Current CCI
      	CCIp=iCCI(Symbol(),0,CCI,PRICE_CLOSE,2);  // Previous CCI
      }
      else if (Method==1)
      {
      	CCIc= CCI(CCI,1);  // Current CCI from codersguru
      	CCIp= CCI(CCI,2);  // Previous CCI from codersguru
      }

      CalDoneEA=true;
   }
   else if (Volume[0]>1) CalDoneEA=false;
   
   if (OrdersTotal()==0)
    {
      if (CCIc>0 && CCIp<=0)   {fBuy();Position=1;}
      if (CCIc<0 && CCIp>=0)   {fSell();Position=2;}
    }
   else
   {                 
      if (ProfitModifySL>0)   fModifySLWhenInProfit();
      if (TrailingStop>0)     fTrailStop();
      
      if (CCIc<0 && CCIp>=0 && Position==1)   {fCloseOpenOrders();fSell();Position=2;}
      if (CCIc>0 && CCIp<=0 && Position==2)   {fCloseOpenOrders();fBuy();Position=1;}
   }

   return(0);
  }
// ***** End of Main Loop ******



//+------------------------------------------------------------------+
//| Buy                                                              |
//+------------------------------------------------------------------+
void fBuy()
{
   int ticket =OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,Ask-StopLoss*Point,Ask+TakeProfit*Point,NULL,Magic,0,clOpenBuy); 
   if(ticket>0)
   {
      if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice());
   }
   else Print("Error opening BUY order : ",GetLastError());
   
}
//+------------------------------------------------------------------+
//| Sell                                                             |
//+------------------------------------------------------------------+
void fSell()
{
   int ticket =OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,Bid+StopLoss*Point,Bid-TakeProfit*Point,NULL,Magic,0,clOpenSell); 
   if(ticket>0)
   {
      if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened : ",OrderOpenPrice());
   }
   else Print("Error opening SELL order : ",GetLastError());
}

//+------------------------------------------------------------------+
//| Scan through Order and if in profit by PrmSL Modify SL           |
//+------------------------------------------------------------------+
void fModifySLWhenInProfit()
{
   for (int i=0; i<OrdersTotal(); i++) 
   { 
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) 
      { 
         if (OrderSymbol()==Symbol() && OrderMagicNumber()==Magic) 
         {
            if (OrderType()==OP_BUY && Bid-OrderOpenPrice()>=ProfitModifySL*Point)
               if (OrderStopLoss()<OrderOpenPrice())  fModifyStopLoss(OrderOpenPrice());
               
            if (OrderType()==OP_SELL && OrderOpenPrice()-Ask>=ProfitModifySL*Point) 
               if (OrderStopLoss()>OrderOpenPrice())  fModifyStopLoss(OrderOpenPrice());
         } 
      } 
    }
}


//+------------------------------------------------------------------+
//| Modify Stop Loss                                                 |
//+------------------------------------------------------------------+
void fModifyStopLoss(double tStopLoss) 
{ 
   bool result = OrderModify(OrderTicket(),OrderOpenPrice(),tStopLoss,OrderTakeProfit(),0,NULL); 
   
   if (result) Print("StopLoss Modified for ticket ",OrderTicket()," to ",tStopLoss);
   else Print("Could not modify Stop Loss for ticket ",OrderTicket()," to ",tStopLoss);
   
}


//+------------------------------------------------------------------+
//| Trailling Stop Loss                                              |
//+------------------------------------------------------------------+
void fTrailStop()
{
   for (int i=0; i<OrdersTotal(); i++) 
   { 
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) 
      { 
         if (OrderSymbol()==Symbol() && OrderMagicNumber()==Magic) 
         {
            if (OrderType()==OP_BUY) 
            { 
               if (Bid-OrderOpenPrice()>TrailingStop*Point) 
               { 
                  if (OrderStopLoss()<Bid-TrailingStop*Point) 
                     fModifyStopLoss(Bid-TrailingStop*Point); 
               }
            }
            if (OrderType()==OP_SELL)
            {
               if (OrderOpenPrice()-Ask>TrailingStop*Point) 
               {
                  if (OrderStopLoss()>Ask+TrailingStop*Point || OrderStopLoss()==0)  
                     fModifyStopLoss(Ask+TrailingStop*Point); 
               }
                   
            } 
         } 
      } 
    } 
}

//+------------------------------------------------------------------+
//| Close all running order                                          |
//+------------------------------------------------------------------+
void fCloseOpenOrders()
{
   bool tClosing;
   
   for (int i=0; i<OrdersTotal(); i++) 
   { 
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) 
      { 
         if (OrderSymbol()==Symbol() && OrderMagicNumber()==Magic) 
         {
            if (OrderType()==OP_BUY)  tClosing = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), Slippage, clCloseBuy );
            if (OrderType()==OP_SELL) tClosing = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), Slippage, clCloseSell );
         } 
      } 
    }
    //return;
}

double CCI(int period, int shift)
{
   double TP = (High[shift]+ Low[shift]+ Close[shift])/3;
   double SMATP = iMA(NULL,0,period,0,MODE_SMA,PRICE_TYPICAL,shift);
   
   double delta_i = 0;
   for ( int i = 0 ; i < period ; i++)
   {
   delta_i = delta_i + MathAbs(iMA(NULL,0,period,0,MODE_SMA,PRICE_TYPICAL,i) - ((High[i]+Low[i]+Close[i])/3));
   }
   double MD = delta_i / period;
   return ((TP - SMATP) / (0.015 * MD));
}  

